#ifndef SEEKBAR_H
#define SEEKBAR_H

#include "skin.h"
#include "skinmanager.h"
#include "skinpanel.h"
#include "skinscrollbar.h"
#include "paintbox.h"

class SeekBar : public LayeredPaintBox
{
	Q_OBJECT
public:
	SeekBar(Skin::PartsType type, const SkinManager *skinmgr, SkinPanel *parent);

    enum BarOrientation {
        Horizontal = 0x1,
        Vertical = 0x2
    };

    virtual void setOrientation(BarOrientation orientation) { orientation_ = orientation; }
    BarOrientation orientation() const { return orientation_; }

	void setMinimum(int value) { }
	void setMaximum(int value) { slider_.setItemCount(value + 1); }
	void setRange(int min, int max) { slider_.setItemCount(max + 1); }

	void setPageStep(int value) { slider_.setItemsPerPage(value); }
	void setTracking(bool value) { }

public slots:
	void setSkin(const Skin *skin);
	void setValue(int value) { slider_.setPosition(value); }

signals:
	void sliderReleased();
	void sliderStepped(int newValue);
	void sliderMoved(int newValue);

protected:
	void paintToBuffer(QImage &buffer, const QRect &clipRect);

private slots:
	void skinPanelResized();

	void sliderHasStepped(float newValue) { emit sliderStepped((int)newValue); }
	void sliderHasMoved(float newValue) { emit sliderMoved((int)newValue); }

private:
	SkinPanel *parent_;
	SkinSlider slider_;
    BarOrientation orientation_;
	const QPixmap *image_;
	QPixmap background_;
	Skin::PartsType type_;
	const SkinParts *parts_;
};

#endif // SEEKBAR_H
